
// plugin events
public OnPluginStart()
{
	PrintToConsole(0, "[ZR] Zombie:DecapiTation loaded.");
	
	CreateConVar("sm_decap_version", PLUGIN_VERSION, "Zombie:DecapiTation Version", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY);

	cvDecapHeadshot = CreateConVar("sm_decap_headshot", "1", "decapination on headshot");
	cvDecapKnife = CreateConVar("sm_decap_knife", "1", "decapination on knifing");
	cvDecapHE = CreateConVar("sm_decap_he", "1", "decapination on grenade");

	HookEvent("player_hurt", EventPlayerHurt, EventHookMode_Pre);
	HookEvent("round_start", EventRoundStart);
	//HookEvent("round_end", EventRoundEnd);
	HookEvent("player_death", EventDeath);
	HookEvent("player_spawn", EventSpawn);
	HookEvent("player_team", EventSpawn);
	
}

public OnEventShutdown()
{
	UnhookEvent("player_hurt", EventPlayerHurt, EventHookMode_Pre);
	UnhookEvent("round_start", EventRoundStart);
	UnhookEvent("player_death", EventDeath, EventHookMode_Pre);
	UnhookEvent("player_spawn",EventSpawn);
	UnhookEvent("player_team",EventTeam);
	
}

public OnMapStart()
{
	//open precache file and add everything to download table
	new String:modelfile[256];
	BuildPath(Path_SM, modelfile, 255, "configs/dc_assetconfig.ini");
	new Handle:fileh = OpenFile(modelfile, "r");
	new String:buffer[256];
	while (ReadFileLine(fileh, buffer, sizeof(buffer)))
	{
		new len = strlen(buffer);
		if (buffer[len-1] == '\n')
   			buffer[--len] = '\0';
   			
		if (FileExists(buffer))
		{
			AddFileToDownloadsTable(buffer);
		}
		
		if (IsEndOfFile(fileh))
			break;
	}
	
	// models
	PrecacheModel("models/player/zh/zh_charple001_hs.mdl",true);
	PrecacheModel("models/player/zh/zh_corpse002_hs.mdl",true);
	PrecacheModel("models/player/zh/zh_zombie003_hs.mdl",true);
	PrecacheModel("models/player/slow/zombie_package/slow_5_hs.mdl",true);
	PrecacheModel("models/player/lextalionis/zombine/t_phoenix_hs.mdl",true);
	PrecacheModel("models/player/ics/t_guerilla_z/t_guerilla_hs.mdl",true);
	PrecacheModel("models/player/ibizagaming/zombie/poison_v2_hs.mdl",true);
	PrecacheModel("models/player/elis/uz1/uz1_hs.mdl",true);

	PrecacheModel("models/player/zh/zh_charple001_head.mdl",true);
	PrecacheModel("models/player/zh/zh_corpse002_head.mdl",true);
	PrecacheModel("models/player/zh/zh_zombie003_head.mdl",true);
	PrecacheModel("models/player/slow/zombie_package/slow_5_head.mdl",true);
	PrecacheModel("models/player/ics/t_guerilla_z/t_guerilla_head.mdl",true);
	PrecacheModel("models/player/lextalionis/zombine/t_phoenix_head.mdl",true);
	PrecacheModel("models/player/ibizagaming/zombie/poison_v2_head.mdl",true);
	PrecacheModel("models/player/elis/uz1/uz1_head.mdl",true);
	
	PrecacheModel("models/props/de_train/utility_truck_windows.mdl",true);

	// particles
	ForcePrecache("blood_advisor_pierce_spray");
	ForcePrecache("blood_advisor_pierce_spray_b");
	ForcePrecache("blood_advisor_pierce_spray_c");	
	ForcePrecache("blood_advisor_puncture");
	ForcePrecache("blood_advisor_puncture_withdraw");
	ForcePrecache("blood_antlionguard_injured_heavy_tiny");
	ForcePrecache("blood_impact_red_01");
	ForcePrecache("blood_impact_red_01_droplets");
	ForcePrecache("blood_impact_red_01_goop");
	ForcePrecache("blood_impact_red_01_mist");
	ForcePrecache("blood_impact_red_01_smalldroplets");
	ForcePrecache("blood_zombie_split_spray");
	ForcePrecache("blood_zombie_split_spray_tiny");
	ForcePrecache("blood_zombie_split_spray_tiny2");
	ForcePrecache("smoke_gib_01");
}

public ForcePrecache(String:ParticleName[])
{
	decl Particle;
	
	Particle = CreateEntityByName("info_particle_system");
	
	if(IsValidEdict(Particle))
	{
		DispatchKeyValue(Particle, "effect_name", ParticleName);
		
		DispatchSpawn(Particle);
		ActivateEntity(Particle);
		AcceptEntityInput(Particle, "start");
		
		CreateTimer(0.3, DeleteParticle, Particle, TIMER_FLAG_NO_MAPCHANGE);
	}
}

public OnClientPutInServer(client)
{
	ResetPlayer(client);
}

public OnClientDisconnect(client)
{
	if((g_HeadEnt[client]) && (IsValidEntity(g_HeadEnt[client])))
	{
		RemoveEdict(g_HeadEnt[client]);
	}

	ResetPlayer(client);
}

public Action:EventRoundStart(Handle:Event, const String:Name[], bool:Broadcast)
{
	for (new client = 1; client <= MaxClients; client++)
	{
		if (IsClientConnected(client) && IsClientInGame(client))
		{
		
		}
	}
	
	return Plugin_Continue;
}
